;;----------------------LICENSE - LEAGUE OF TANKS - GPL---------------------------
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;
;;---------------------------------------------------------------------------------
;;
;;======================================================================================================================================================
;; Title:  League of Tanks                                                                
;; Team: Nibble Games                       -- NibbleGamesMultimedia@gmail.com
;; Authors: 
;; Emilio José Pérez Mariscal               --  ejperezmariscal@hotmail.com -- https://www.linkedin.com/in/emilio-jos%C3%A9-p%C3%A9rez-mariscal-78b39a196/
;; Jesús Cuadra Téllez                      --  cuadrabc2015@gmail.com      -- https://www.linkedin.com/in/jesus-cuadra-tellez-0931a6189/
;; Francisco Javier García Fernandez        --  fjgfuniabp1398@gmail.com    
;; Date: 29/10/2019
;;=======================================================================================================================================================

;;
;;Clean entities h
;;

;; IX: puntero de la entidad que queremos limpiar
;; A: NUMBER OF ENTITIES TO RENDER 
.include "cpct_functions.h.s"
.include "man/entity_manager.h.s"
.include "man/shot_manager.h.s"
.include "man/manager_buffer.h.s"


clean_entities_init::
 call entityman_getEntityVector_IX
 call entityman_num_entities


ld (_contador_entidades),a
ld (_puntero_entidades), ix


 call entityman_getArray_Bales  ;; cogemos en ix el puntero a las balas
 call entityman_num_Bales
 ld (_contador_balas), hl
 ld (_puntero_balas), ix
ret


clean_entities::
  

 call _clean_canon
 call _clean_balas	
ret





_clean_canon:

_contador_entidades=.+1
	ld a, #00
_puntero_entidades=.+2
ld ix, #0000
_cleanloop:

push af  
	
	
   ld a ,e_dead(ix)
  dec a
  jr z, _canon_muerto 

 call map_getVideoPrt  ;; esta funcion te da el puntero de el primer byte de la posicion de memoria del buffer que estamos en ese momento en hl
  ex de, hl
 
  ld   c, e_xll(ix)  
  ld   b, e_yll(ix)  
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   ex  de,hl
 

  
ld  a, #0x00  ;;color
ld  c, #4 	;;width
ld  b, #16	;;height
call cpct_drawSolidBox_asm

_canon_muerto:

pop af 


dec a
ret z

ld bc, #siceof_e ;;byte de cada entidad
add ix, bc
jr nz, _cleanloop


ret





_clean_balas::

 _puntero_balas=.+2
 ld ix, #0000
 _contador_balas=.+1
 ld hl, #0000
 ld a ,(hl)
 or a 
 	jr z, _no_hay_balas

	
	_cleanloop_balas:
	push af
	   
	 call map_getVideoPrt  ;; esta funcion te da el puntero de el primer byte de la posicion de memoria del buffer que estamos en ese momento en hl
	  ex de, hl
	 
	  ld   c, b_xll(ix)  
	  ld   b, b_yll(ix)  
	  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
	   ex  de,hl
	 

	  
	ld  a, #0x00   ;; color
	ld  c, b_w(ix)	;; width
	ld  b, b_h(ix)	;; height ;;**
	call cpct_drawSolidBox_asm


	pop af 

	dec a
	ret z

	ld bc, #siceof_b ;;byte de cada BALA
	add ix, bc
	jr nz, _cleanloop_balas
_no_hay_balas:

ret  




limpiar_ultimo::


 ;;call map_getVideoPrt  ;; esta funcion te da el puntero de el primer byte de la posicion de memoria del buffer que estamos en ese momento en hl
  ;;ex de, hl
  ld de ,#0xc000
  ld   c, e_x(iy)  
  ld   b, e_y(iy)  
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
  ex  de,hl  
 ld  a, #0x00  ;;color
 ld  c, #4 	;;width
 ld  b, #16	;;height
 call cpct_drawSolidBox_asm



 ld de ,#0x8000
 ld   c, e_x(iy)  
 ld   b, e_y(iy)  
 call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
 ex  de,hl  
 ld  a, #0x00  ;;color
 ld  c, #4 	;;width
 ld  b, #16	;;height
 call cpct_drawSolidBox_asm

   ld de ,#0xc000
  ld   c, e_xl(iy)  
  ld   b, e_yl(iy)  
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
  ex  de,hl  
 ld  a, #0x00  ;;color
 ld  c, #4 	;;width
 ld  b, #16	;;height
 call cpct_drawSolidBox_asm



 ld de ,#0x8000
 ld   c, e_xl(iy)  
 ld   b, e_yl(iy)  
 call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
 ex  de,hl  
 ld  a, #0x00  ;;color
 ld  c, #4 	;;width
 ld  b, #16	;;height
 call cpct_drawSolidBox_asm

   ld de ,#0xc000
  ld   c, e_xll(iy)  
  ld   b, e_yll(iy)  
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
  ex  de,hl  
 ld  a, #0x00  ;;color
 ld  c, #4 	;;width
 ld  b, #16	;;height
 call cpct_drawSolidBox_asm



 ld de ,#0x8000
 ld   c, e_xll(iy)  
 ld   b, e_yll(iy)  
 call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
 ex  de,hl  
 ld  a, #0x00  ;;color
 ld  c, #4 	;;width
 ld  b, #16	;;height
 call cpct_drawSolidBox_asm

ret


limpiar_ultima::


 ;;call map_getVideoPrt  ;; esta funcion te da el puntero de el primer byte de la posicion de memoria del buffer que estamos en ese momento en hl
  ;;ex de, hl
 

	 ld de ,#0xc000

 	ld   c, b_xl(ix)  
	ld   b, b_yl(ix)  

	call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
	 ex  de,hl	
	ld  a, #0x00   ;; color
	ld  c, b_w(ix)	;; width
	ld  b, b_h(ix)	;; height ;;**
	call cpct_drawSolidBox_asm

  ld de ,#0x8000
	ld   c, b_xl(ix)  
	ld   b, b_yl(ix)  
	call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
	 ex  de,hl	
	ld  a, #0x00   ;; color
	ld  c, b_w(ix)	;; width
	ld  b, b_h(ix)	;; height ;;**
	call cpct_drawSolidBox_asm

	 

	  ld de ,#0xc000

 	ld   c, b_xll(ix)  
	ld   b, b_yll(ix)  
	call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
	 ex  de,hl	
	ld  a, #0x00   ;; color
	ld  c, b_w(ix)	;; width
	ld  b, b_h(ix)	;; height ;;**
	call cpct_drawSolidBox_asm

  ld de ,#0x8000
	ld   c, b_xll(ix)  
	ld   b, b_yll(ix)  
	call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
	 ex  de,hl	
	ld  a, #0x00   ;; color
	ld  c, b_w(ix)	;; width
	ld  b, b_h(ix)	;; height ;;**
	call cpct_drawSolidBox_asm

	 ld de ,#0xc000

 	

ret


