;;----------------------LICENSE - LEAGUE OF TANKS - GPL---------------------------
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;
;;---------------------------------------------------------------------------------
;;
;;======================================================================================================================================================
;; Title:  League of Tanks                                                                
;; Team: Nibble Games                       -- NibbleGamesMultimedia@gmail.com
;; Authors: 
;; Emilio José Pérez Mariscal               --  ejperezmariscal@hotmail.com -- https://www.linkedin.com/in/emilio-jos%C3%A9-p%C3%A9rez-mariscal-78b39a196/
;; Jesús Cuadra Téllez                      --  cuadrabc2015@gmail.com      -- https://www.linkedin.com/in/jesus-cuadra-tellez-0931a6189/
;; Francisco Javier García Fernandez        --  fjgfuniabp1398@gmail.com    
;; Date: 29/10/2019
;;=======================================================================================================================================================

;;
;;RENDER SYSTEM
;;

.include "assets.h.s"
.include "cpct_functions.h.s"
.include "man/state_manager.h.s"
.include "man/plant_manager.h.s"
.include "man/manager_buffer.h.s"
.include "man/entity_manager.h.s"
.include "sys/sys_map_colision.h.s"
.include "sys/render_system.h.s"
.include "sys/plant_render.h.s"
.include "sys/sys_interrup_music.h.s"
.include "sys/sys_a.h.s"
.include "sys/clean_entities.h.s"



plant_update::



  call plantman_getPlanta ;;Devuelve en ix la planta
  ld a, p_cont(ix)
  dec a
  ld p_cont(ix), a
  jr nz, nocambio
  ld a, p_cont2(ix)
  dec a
  ld p_cont2(ix), a
  jr nz, nocambio
  ld a, p_spawning(ix)
  dec a
  jr z, no_clean
    call clean_plant
  no_clean:
  ld a, #2
  ld p_cont2(ix), a
  ld a, #0xFF
  ld p_cont(ix), a
  ld a, #0
  ld p_activa(ix), a
  ld p_spawning(ix), a

  nocambio:

  
  ld a, p_activa(ix)
  dec a
  jr nz, _novalido
  call check_plant_col
  ret 





  _novalido:

  _incorrecto_lmayorquea:
  call cpct_getRandom_mxor_u8_asm
  ld a, #74
  sub l
  jr c, _incorrecto_lmayorquea
  ld b, l
  push bc

    _incorrecto_lmayorquea2:
  call cpct_getRandom_mxor_u8_asm
  ld a, #144
  sub l
  jr c, _incorrecto_lmayorquea2
  pop bc
  ld c, l
  ld d, #4
  ld e, #16

  ld h, #3


  push de
  push bc
  dec b
  call comp_colisiones ;devuelve en a 1 si no hay colision
  pop bc
  pop de

  dec a
  jr nz, _novalido
  ld h, #1
  push bc
  inc b 
  call comp_colisiones ;devuelve en a 1 si no hay colision
  pop bc
  dec a
  jr nz, _novalido



  call plantman_getPlanta ;;Devuelve en ix la planta




  ld   p_x(ix), b ;;x
  ld   p_y(ix), c;;y
  ld   a, #1
  ld   p_activa(ix), a

  call check_plant_col
 
ret



reset_plant::

  call plantman_getPlanta ;;Devuelve en ix la planta
  ld a, #0
  ld p_x(ix), a
  ld p_y(ix), a
  ld a, #250
  ld p_cont(ix), a
  ld a, #1
  ld p_cont2(ix), a
  ld p_spawning(ix), a
  ld p_activa(ix), a

  call clean_plant
 


ret








check_plant_col::




  call entityman_getEntityVector_IX

     


ld (cambiar_ix_iy), ix
cambiar_ix_iy=.+2
ld iy, #0000

  call plantman_getPlanta ;;Devuelve en ix la planta

  ;;Comprobar que acabade respawnear y no debe atacar en ese tiempo
  ld a,  p_cont2(ix)
  cp #2
  jr nz, _normal_col
  ld a, p_cont(ix)
  sub #0xA0
  jr nc, _nocoliding
  ;;Endcomprobar





  _normal_col:

  call entityman_num_entities
_loop_tankes:
  push af

  ld a , p_spawning(ix)
  dec a
  jr z, _nocheck
  
  ld a ,e_dead(iy)
  dec a
  jr z, _nocheck

  ld a, (_gamemode);;Si es ia no le mata la planta, pero si estamos en multijugador si
  cp #5
  jr nz, _plantamataia
  ;;Si es ia no les mata
  ld a , e_ia_st(iy)
  cp #00
  jr nz, _nocheck
  _plantamataia:

    

    
 
  

     ;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ;;comprobar si choca en x;;
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ld d ,#1 ;;NO CHOCA

    ld b , e_x(iy)        ;;b esquina izquierda en x canon
    ld c , e_ancho(iy)       


    ld a, b
    add c
    ld c, a         ;; c esquina derecha en x canon


    ld a , p_x(ix)        
    sub c           ;; comprobamos si la esquina derecha de canon es mayor que la esquina izquierda de la bala 
    jr nc , _planta_nochoca_x

    ;;Segundo caso en X
      ld a, p_x(ix)
      add p_ancho(ix) 
      sub b

      jr c ,_planta_nochoca_x
     
       ld d ,#0
    ;;Planta choca en X;

    

    
    ;;;;;;;;;;;;;;;;;;;;;
    ;; comprobamos la y;;
    ;;;;;;;;;;;;;;;;;;;;;


    ;;b esquina arriba en y canon
    ld b , e_y(iy) 
    ld c , e_alto(iy) 
    ld a, b
    add c
    ld c, a         ;; c esquina abajo en y canon
      
    ld a , p_y(ix)    
    sub c
    jr nc, _planta_nochoca_y
    ;;Segundo caso Y:

      ld a, p_y(ix)
      add p_alto(ix) 
      sub b
      jr c ,_planta_nochoca_y
      
      ;;Planta choca en y


          ld a ,d
          or a
          jr nz, _planta_nochoca_x      
       
          push ix
          push iy
            ld e_dead(iy), #1
            call jugador_muerto
            call limpiar_ultimo
            call sonido_muerte
            call iniciar_animacion_canon
          pop iy
          pop ix
    _planta_nochoca_x:
    _planta_nochoca_y:

    


  _nocheck:
  
  ld bc, #siceof_e    ;;NUMERO DE BYTES QUE TIENE CADA canon
  add iy, bc
  pop af
  dec a
  ret z
  

  jp _loop_tankes

  _nocoliding:








ret