;;----------------------LICENSE - LEAGUE OF TANKS - GPL---------------------------
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;
;;---------------------------------------------------------------------------------
;;
;;======================================================================================================================================================
;; Title:  League of Tanks                                                                
;; Team: Nibble Games                       -- NibbleGamesMultimedia@gmail.com
;; Authors: 
;; Emilio José Pérez Mariscal               --  ejperezmariscal@hotmail.com -- https://www.linkedin.com/in/emilio-jos%C3%A9-p%C3%A9rez-mariscal-78b39a196/
;; Jesús Cuadra Téllez                      --  cuadrabc2015@gmail.com      -- https://www.linkedin.com/in/jesus-cuadra-tellez-0931a6189/
;; Francisco Javier García Fernandez        --  fjgfuniabp1398@gmail.com    
;; Date: 29/10/2019
;;=======================================================================================================================================================

;;
;;RENDER SYSTEM
;;

.include "cpct_functions.h.s"
.include "man/plant_manager.h.s"
.include "man/manager_buffer.h.s"
.include "plant_physics.h.s"
.include "assets.h.s"





plant_render::

  
  call plantman_getPlanta ;;Devuelve en ix la planta
  ld a, p_spawning(ix)
  dec a
  jr z, _norenderplant



  ld de, #0xC000
  ld   c, p_x(ix)  ;;x
  ld   b, p_y(ix)  ;;y
  call cpct_getScreenPtr_asm
  ex de, hl

 ld l, p_sprite(ix)
 ld h, p_sprite2(ix)
 ld c, #04  ;;ancho
 ld b, #16  ;;alto
 
 call cpct_drawSprite_asm

  
  call plantman_getPlanta ;;Devuelve en ix la planta

  ;;Comprobar que acabade respawnear y no debe atacar en ese tiempo
  ld a,  p_cont2(ix)
  cp #2
  jr nz, _normalrender
  ld a, p_cont(ix)
  sub #0xA0
  ret nc
  ;;Endcomprobar

  _normalrender:

  ld de, #0x8000
  ld   c, p_x(ix)  ;;x
  ld   b, p_y(ix)  ;;y
  call cpct_getScreenPtr_asm
  ex de, hl

 ld l, p_sprite(ix)
 ld h, p_sprite2(ix)
 ld c, #04  ;;ancho
 ld b, #16  ;;alto
 
 call cpct_drawSprite_asm
 


_norenderplant:

ret


clean_plant::


  
  ld de, #0xc000
  ld   c, p_x(ix)  
  ld   b, p_y(ix)  
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   ex  de,hl
 

  
ld  a, #0x00  ;;color
ld  c, #4 	;;width
ld  b, #16	;;height
call cpct_drawSolidBox_asm



  ld de, #0x8000
  ld   c, p_x(ix)  
  ld   b, p_y(ix)  
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   ex  de,hl
 

  
ld  a, #0x00  ;;color
ld  c, #4 	;;width
ld  b, #16	;;height
call cpct_drawSolidBox_asm


ret