;;----------------------LICENSE - LEAGUE OF TANKS - GPL---------------------------
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;
;;---------------------------------------------------------------------------------
;;
;;======================================================================================================================================================
;; Title:  League of Tanks                                                                
;; Team: Nibble Games                       -- NibbleGamesMultimedia@gmail.com
;; Authors: 
;; Emilio José Pérez Mariscal               --  ejperezmariscal@hotmail.com -- https://www.linkedin.com/in/emilio-jos%C3%A9-p%C3%A9rez-mariscal-78b39a196/
;; Jesús Cuadra Téllez                      --  cuadrabc2015@gmail.com      -- https://www.linkedin.com/in/jesus-cuadra-tellez-0931a6189/
;; Francisco Javier García Fernandez        --  fjgfuniabp1398@gmail.com    
;; Date: 29/10/2019
;;=======================================================================================================================================================

;;
;; FUNCTION: Redimensiona el array de balas, cuando una de las balas ha coliionado o con un enemigo, o con el escenario
;; INPUT: Bala a eliminar (IX) y Numero de bala a borrar (H)
;; CHANGE: Memoria reservada para las balas en el entity manager
;;

.include "sys_kill_bullet.h.s"
.include "man/shot_manager.h.s"
.include "man/entity_manager.h.s"
.include "sys/clean_entities.h.s"
.include "sys/sys_a.h.s"

kill_bullet_init::

 call entityman_getArray_Bales  ;; cogemos en ix el puntero a las balas
 call entityman_num_Bales
 ld (_contador_balas), hl
 ld (_puntero_balas), ix

  ret


kill_bullet::
push af
 call iniciar_animacion_bala
 call limpiar_ultima
pop af
ld c, a

call devolver_tiro





ld (puntero_entidad_a_eliminar),ix


call entityman_num_Bales
ld a, (hl)
sub c

ld c, a
ld a, #max_bales
sub c
dec a
;; aqui tengo el numero de entidades que tengo que mover


puntero_entidad_a_eliminar=.+1
ld de, #0000
ld hl ,(puntero_entidad_a_eliminar)
ld bc ,#siceof_b
add hl,bc


_seguimos_limpiando:
ld bc ,#siceof_b
ldir
dec a
jr nz, _seguimos_limpiando





call entityman_num_Bales
ld a, (hl)
dec a
ld (hl), a




  






 ret


devolver_tiro:

ld h, b_canon_h(ix)
ld l, b_canon_l(ix)
ld de, #e_sh
add hl, de
ld (hl), #0

 ret






 kill_bullet_all::

 _puntero_balas=.+2
  ld ix, #0000
  _contador_balas=.+1
 ld hl , #0000
 ld (hl),a
 or a
 jr nz, _limpiamos_array_de_balas
ret

_limpiamos_array_de_balas:
  _loop_clean:
   ld (_puntero_limpiar), ix
     _puntero_limpiar = . + 1
     ld de, #0x0000
     ex de,hl
     inc de
     ld bc, #siceof_b
     ldir
     dec a
     ret z
     jr _limpiamos_array_de_balas

  ret